module  output_laure16_mod

  use module3D_phy
  use bilan_eau_mod
  use bilan_flux_mod
  use netcdf
  use io_netcdf_grisli

implicit none

logical,dimension(nx,ny,7) :: mask_cal !< masque regions calotte 
real,dimension(nx,ny) :: corrsurf     !< facteur de correction de la surface


! variables netcdf
integer,parameter :: ncshortout=1 ! 1 sorties netcdf short initMIP
integer,parameter :: nvar=10 ! nombre de variables dans le fichier de sortie temporel netcdf 
integer :: ncid
integer :: status
integer :: timeDimID
integer :: timeVarID
integer,dimension(nvar) :: varID
integer :: nbtimeout  ! index time output

real,dimension(nvar) :: var_shortoutput

contains
!_________________________________________________________________________
subroutine init_outshort


double precision,dimension(:,:),pointer      :: tab               !< tableau 2d real pointer
character(len=100),dimension(nvar) :: namevar ! name, standard_name, long_name,units
character(len=100),dimension(nvar) :: standard_name
character(len=100),dimension(nvar) :: long_name
character(len=100),dimension(nvar) :: units


!ndisp sorite courte tous les ndisp
NDISP=100
mask_cal(:,:,:)=.false.
mask_cal(:,:,1)=.true.
! calcul d'un masque pour les regions des calottes
do j=1,ny
   do i=1,nx
! -- Laurentide
      if( (((xlong(i,j).ge.190).and.(xlong(i,j).lt.210)).and. &
           ((ylat(i,j).ge.50).and.(ylat(i,j).le.70))).or.      &
           (((xlong(i,j).ge.210).and.(xlong(i,j).lt.220)).and. &
           ((ylat(i,j).ge.55).and.(ylat(i,j).le.75))).or.      &
           (((xlong(i,j).ge.220).and.(xlong(i,j).lt.250)).and. & 
           ((ylat(i,j).ge.40).and.(ylat(i,j).le.85))).or.      &
           (((xlong(i,j).ge.250).and.(xlong(i,j).lt.290)).and. &
           ((ylat(i,j).ge.35).and.(ylat(i,j).le.85))).or.      &
           (((xlong(i,j).ge.290).and.(xlong(i,j).lt.300)).and. &
           ((ylat(i,j).ge.35).and.(ylat(i,j).le.75))).or.      &
           (((xlong(i,j).ge.300).and.(xlong(i,j).le.310)).and. &
           ((ylat(i,j).ge.35).and.(ylat(i,j).lt.60))) ) mask_cal(i,j,2)=.true.
! -- Groenland
      if( (((xlong(i,j).ge.290).and.(xlong(i,j).le.310)).and. &
           ((ylat(i,j).ge.75).and.(ylat(i,j).le.85))).or.      &
           (((xlong(i,j).ge.300).and.(xlong(i,j).lt.310)).and. &
           ((ylat(i,j).ge.60).and.(ylat(i,j).le.75))).or.      &
           (((xlong(i,j).ge.310).and.(xlong(i,j).le.345)).and. &
           ((ylat(i,j).ge.54).and.(ylat(i,j).le.85))) ) mask_cal(i,j,3)=.true.
! -- Labrador Sector 
      if((((xlong(i,j).ge.285).and.(xlong(i,j).le.300)).and.  &
           ((ylat(i,j).ge.35).and.(ylat(i,j).le.70))).or.      &
           (((xlong(i,j).ge.300).and.(xlong(i,j).lt.310)).and. &
           ((ylat(i,j).ge.35).and.(ylat(i,j).lt.60)))) mask_cal(i,j,4)=.true.
! -- Keewatin Sector 
      if(  ((xlong(i,j).gt.240).and.(xlong(i,j).lt.285)).and. &
           ((ylat(i,j).ge.35).and.(ylat(i,j).le.70)) ) mask_cal(i,j,5)=.true.
! -- Innuitian Ice Sheet
      if( ((xlong(i,j).gt.230).and.(xlong(i,j).lt.290)).and. &
           ((ylat(i,j).gt.70).and.(ylat(i,j).le.85))) mask_cal(i,j,6)=.true.
! -- Cordilleran Ice Sheet
      if( (((xlong(i,j).ge.190).and.(xlong(i,j).lt.210)).and. &
           ((ylat(i,j).ge.50).and.(ylat(i,j).le.70))).or.      &
           (((xlong(i,j).ge.210).and.(xlong(i,j).lt.220)).and. &
           ((ylat(i,j).ge.55).and.(ylat(i,j).le.75))).or.      &
           (((xlong(i,j).ge.210).and.(xlong(i,j).lt.220)).and. &
           ((ylat(i,j).ge.55).and.(ylat(i,j).le.75))).or.     &
           (((xlong(i,j).ge.220).and.(xlong(i,j).le.240)).and. &
           ((ylat(i,j).ge.40).and.(ylat(i,j).le.70))) ) mask_cal(i,j,7)=.true.
   enddo
enddo

! hemin40    : time,isvol,deltavol,inp,isvolf,inf
! ecriture entete avec les colonnes du fichier short :
write(num_ritz, '(a45)')"! laure16    : time,isvol,inp,isvolf,inf,volf"
write(num_ritz, '(a82)')"! colonne    :    1         2           3             4             5            6"
write(num_ritz,'(a91)')"! calotte    : Laurentide Groenland LabradorSector KeewatinSector InnuitianIS CordilleranIS"
write(num_ritz,'(a83)')"! isvol      :    7        12          17            22            27            32"
write(num_ritz,'(a83)')"! inp        :    8        13          18            23            28            33"
write(num_ritz,'(a83)')"! isvolf     :    9        14          19            24            29            34"
write(num_ritz,'(a83)')"! inf        :    10       15          20            25            30            35"
write(num_ritz,'(a83)')"! volaf      :    11       16          21            26            31            36"
write(num_ritz,'(a61)')"! water bilan: diff_H,water_bilan, calving, ablbord, Bm, bmelt"
write(num_ritz,'(a83)')"! colonne    :    37       38          39            40            41            42"
write(num_ritz,*)


if (ncshortout.eq.1) then  ! ecriture netcdf

! lecture du fichier avec les corrections de surface
   if (geoplace.eq.'ant16km') then
      call Read_Ncdf_var('z',trim(DIRNAMEINP)//'/corrsurf-initMIP-16km.grd',tab)
      corrsurf(:,:)=tab(:,:)
   else
      corrsurf(:,:)= 1.
   end if

   open(568,file=trim(dirsource)//'/Fichiers-parametres/short-ISMIPnc.dat',status='old')
! lecture en-tete
   read(568,*)
   read(568,*)
   read(568,*)
   read(568,*)
   read(568,*)
! lecture des infos sur les variables :
   do k=1,nvar
      read(568,'(a100)') namevar(k)
      read(568,'(a100)') standard_name(k)
      read(568,'(a100)') long_name(k)
      read(568,'(a100)') units(k)
      read(568,*)
   enddo
   close(568)
! Fichier Netcdf initMIP
! creation du fichier Netcdf :
   status=nf90_create(path = trim(dirnameout)//'short'//runname//'.nc', cmode = nf90_clobber, ncid = ncid)
   if (status /= nf90_noerr) call handle_err(status)

! definition des dimension :
   status=nf90_def_dim(ncid, name="time", len=NF90_UNLIMITED, dimid=timeDimID)
   if (status /= nf90_noerr) call handle_err(status)
   status=nf90_def_var(ncid, name="time", xtype=nf90_float, dimids=(/ timeDimID/), varid=timeVarID) 
   if (status /= nf90_noerr) call handle_err(status)
   status=nf90_put_att(ncid, timeVarID, "standard_name", "time")
   if (status /= nf90_noerr) call handle_err(status)
   status=nf90_put_att(ncid, timeVarID,"units", "years since 1995-01-01 00:00:00")
   if (status /= nf90_noerr) call handle_err(status)
   status=nf90_put_att(ncid, timeVarID,"calendar", "360_day")
   if (status /= nf90_noerr) call handle_err(status)
  
! definition des variables de sortie :
   do k=1,nvar  ! boucle sur le nbr de variable a definir
      status=nf90_def_var(ncid, name=trim(namevar(k)), xtype=nf90_float, dimids= &
           (/ timeDimID /), varid=varID(k))
      if (status /= nf90_noerr) call handle_err(status)
      status=nf90_put_att(ncid, varID(k), "standard_name", trim(standard_name(k)))
      if (status /= nf90_noerr) call handle_err(status)
      status=nf90_put_att(ncid, varID(k), "long_name", trim(long_name(k)))
      if (status /= nf90_noerr) call handle_err(status)
      status=nf90_put_att(ncid, varID(k), "units", trim(units(k)))
      if (status /= nf90_noerr) call handle_err(status)
   enddo

! fin de la definition du fchier :
   status=nf90_enddef(ncid)
   if (status /= nf90_noerr) call handle_err(status)
   nbtimeout = 0 ! initialisation compteur sorties axe time
  
else ! pas de sortie netcdf et sans correction de surface
   corrsurf(:,:)=1.
endif

end subroutine init_outshort

!_________________________________________________________________________
subroutine shortoutput

! 1_initialization
!------------------

  ! ISMIP type outputs: (nc file)
  real :: lim                           !< Total ice mass
  real :: volf                          !< volume above flotation (kg)
  real :: iareag                        !< surface posee
  real :: iareaf                        !< surface flottante
  real :: tendacabf                     !< Total SMB flux
  real :: tendlibmassbf                 !< Total Basal mass balance flux
  real :: tendlibmassbffl               !< Total Basal mass balance flux on floating ice
  real :: tendlicalvf                   !< Total calving flux
  real :: tendlifmassbf                 !< Total calving and ice front melting flux
  real :: tendligroundf                 !< Total grounding line flux

  ! old-version outputs: (ritz file)
  real inp(7) ! Surface posee (nb de noeuds)
  real inf(7) ! surface flottante
  real isvol(7),isvolf(7) ! volume pos et flottants     
  real volfm(7)           ! volume above floatation (m3)


      do k = 1,7
         
         inp(k) = sum(corrsurf(:,:),mask=(mask_cal(:,:,k).and.(ice(:,:).eq.1).and..not.flot(:,:)))
         inf(k) = sum(corrsurf(:,:),mask=(mask_cal(:,:,k).and.(ice(:,:).eq.1).and.flot(:,:)))
         isvol(k) = sum(h(:,:)*corrsurf(:,:),mask=(mask_cal(:,:,k).and.(ice(:,:).eq.1).and..not.flot(:,:)))
         isvolf(k) = sum(h(:,:)*corrsurf(:,:),mask=(mask_cal(:,:,k).and.(ice(:,:).eq.1).and.flot(:,:)))

         volfm(k) = sum(h(:,:)*corrsurf(:,:), mask=(mask_cal(:,:,k).and.(ice(:,:).eq.1).and.(sealevel_2d(:,:)-B(:,:).le.0.)))
         volfm(k) = volfm(k)+sum ((h(:,:)-row/ro*(sealevel_2d(:,:)-b(:,:)))*corrsurf(:,:), mask=(mask_cal(:,:,k).and.(ice(:,:).eq.1).and.(sealevel_2d(:,:)-B(:,:).gt.0.)))
         
      enddo

      inp(:)    = inp(:)*dx*dy
      inf(:)    = inf(:)*dx*dy
      isvol(:)  = isvol(:)*dx*dy
      isvolf(:) = isvol(:)*dx*dy
      volfm(:)  = volfm(:)*dx*dy
      

      !lim=sum(h(:,:)*corrsurf(:,:),mask=(ice(:,:).eq.1))                                              ! grounded volume
      !iareag=sum(corrsurf(:,:),mask=(ice(:,:).eq.1).and.(.not.flot(:,:)))                             ! grounded area
      !iareaf=sum(corrsurf(:,:),mask=(ice(:,:).eq.1).and.flot(:,:))                                    ! floating area
      tendacabf=sum(corrsurf(:,:)*bm_dtt(:,:),mask=(ice(:,:).eq.1))/dtt_flux                           ! smb
      tendlibmassbf=sum(-corrsurf(:,:)*bmelt_dtt(:,:),mask=(ice(:,:).eq.1))/dtt_flux                   ! basal melt
      tendlibmassbffl=sum(-corrsurf(:,:)*bmelt_dtt(:,:),mask=((ice(:,:).eq.1).and.flot(:,:)))/dtt_flux ! subshelf melt
      tendlicalvf=sum(corrsurf(:,:)*calv_dtt(:,:))/dtt_flux                                            ! calving flux
      tendlifmassbf=sum(corrsurf(:,:)*(calv_dtt(:,:)-ablbord_dtt))/dtt_flux                            ! calving+ablbord flux
      tendligroundf=sum(corrsurf(:,:)*grline_dtt(:,:))/dtt_flux                                        ! grounding line flux
     
      lim=isvol(1)*ice_density !lim*dx*dy*ice_density
      iareag=inp(1)            !iareag*dx*dy 
      iareaf=inf(1)            !iareaf*dx*dy
      volf=volfm(1)*ice_density
      tendacabf=tendacabf*dx*dy*ice_density/secyear
      tendlibmassbf=tendlibmassbf*dx*dy*ice_density/secyear
      tendlibmassbffl=tendlibmassbffl*dx*dy*ice_density/secyear
      tendlicalvf=tendlicalvf*dx*dy*ice_density/secyear
      tendlifmassbf=tendlifmassbf*dx*dy*ice_density/secyear
      tendligroundf=tendligroundf*ice_density/secyear


! 2_writing outputs
!------------------

      write(num_ritz,905)   time,isvol(1),inp(1),isvolf(1),inf(1),volfm(1),    &   ! 6
           isvol(2),inp(2),isvolf(2),inf(2),volfm(2), & ! 5
           isvol(3),inp(3),isvolf(3),inf(3),volfm(3), & ! 5
           isvol(4),inp(4),isvolf(4),inf(4),volfm(4), & ! 5
           isvol(5),inp(5),isvolf(5),inf(5),volfm(5), & ! 5
           isvol(6),inp(6),isvolf(6),inf(6),volfm(6), & ! 5
           isvol(7),inp(7),isvolf(7),inf(7),volfm(7), & ! 5
           diff_H, water_bilan, sum(calv_dtt(:,:))/dtt, sum(ablbord_dtt(:,:))/dtt, sum(Bm_dtt(:,:))/dtt, sum(bmelt_dtt(:,:))/dtt !6



!!905 format(f0.2,7(1x,2(e10.5,i6,1x),e10.5), 6(1x,e15.8))
905 format(f0.2,7(1x,e15.8,1x,e15.8,1x,e15.8,1x,e15.8,1x,e15.8), 6(1x,e15.8))

      if (ncshortout.eq.1) then  ! ecriture netcdf
         ! Total ice mass
         var_shortoutput(1)=lim
         ! Mass above floatation
         var_shortoutput(2)=volf
         ! Grounded ice area
         var_shortoutput(3)=iareag
         ! Floating ice area
         var_shortoutput(4)=iareaf
         ! Total SMB flux 
         var_shortoutput(5)=tendacabf
         ! Total Basal mass balance flux
         var_shortoutput(6)=tendlibmassbf
         ! Total Basal mass balance flux beneath floating ice
         var_shortoutput(7)=tendlibmassbffl
         ! Total calving flux 
         var_shortoutput(8)=tendlicalvf
         ! Total calving and ice front melting flux
         var_shortoutput(9)=tendlifmassbf
         ! Total grounding line flux
         var_shortoutput(10)=tendligroundf

         nbtimeout=nbtimeout+1
         
         status=nf90_put_var(ncid, timeVarID, time, start=(/nbtimeout/))
         if (status /= nf90_noerr) call handle_err(status)
         
         do k=1,nvar  ! boucle sur le nbr de variable a ecrire
            status=nf90_put_var(ncid, varID(k), var_shortoutput(k),start=(/nbtimeout/))
            if (status /= nf90_noerr) call handle_err(status)
         enddo
         status=nf90_sync(ncid)
         if (status /= nf90_noerr) call handle_err(status)
      endif


end subroutine shortoutput

subroutine handle_err(status)
  integer, intent(in) :: status
  if (status /= nf90_noerr) then
     print*,trim(nf90_strerror(status))
     stop "stopped"
  end if
end subroutine handle_err

end module output_laure16_mod
